module HashExtensions
  refine Hash do
    def transform_keys
      result = {}
      each_key do |key|
        result[yield(key)] = self[key]
      end
      result
    end

    def symbolize_keys
      symbolized = {}
      each do |key, value|
        new_key = key.to_sym rescue key
        new_val = if value.is_a? Hash
                    value.symbolize_keys
                  else
                    value
                  end
        symbolized[new_key] = new_val
      end
      symbolized
    end

    def stringify_values
      transformed = dup
      transformed.each do |key, value|
        new_val = if value.is_a? Hash
                    value
                  elsif value.is_a? Array
                    value
                  else
                    value.to_s
                  end
        transformed[key] = new_val
      end
    end
  end
end
